Package fr.gouv.vitam.common.database.builder.query

# Class QueryHelper

java.lang.Object
fr.gouv.vitam.common.database.builder.query.QueryHelper

Direct Known Subclasses:
  `QueryParserHelper`

public class QueryHelper extends Object
Query helper (common to all types: SELECT, UPDATE, INSET, DELETE)

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `QueryHelper()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static final BooleanQuery`
  `and()`
  `static final CompareQuery`
  `eq(String variableName, boolean value)`
  `static final CompareQuery`
  `eq(String variableName, double value)`
  `static final CompareQuery`
  `eq(String variableName, long value)`
  `static final CompareQuery`
  `eq(String variableName, String value)`
  `static final CompareQuery`
  `eq(String variableName, Date value)`
  `static final ExistsQuery`
  `exists(String variableName)`
  `static final MltQuery`
  `flt(String value, String... variableName)`
  `static final CompareQuery`
  `gt(String variableName, boolean value)`
  `static final CompareQuery`
  `gt(String variableName, double value)`
  `static final CompareQuery`
  `gt(String variableName, long value)`
  `static final CompareQuery`
  `gt(String variableName, String value)`
  `static final CompareQuery`
  `gt(String variableName, Date value)`
  `static final CompareQuery`
  `gte(String variableName, boolean value)`
  `static final CompareQuery`
  `gte(String variableName, double value)`
  `static final CompareQuery`
  `gte(String variableName, long value)`
  `static final CompareQuery`
  `gte(String variableName, String value)`
  `static final CompareQuery`
  `gte(String variableName, Date value)`
  `static final InQuery`
  `in(String variableName, boolean... value)`
  `static final InQuery`
  `in(String variableName, double... value)`
  `static final InQuery`
  `in(String variableName, long... value)`
  `static final InQuery`
  `in(String variableName, String... value)`
  `static final InQuery`
  `in(String variableName, Date... value)`
  `static final ExistsQuery`
  `isNull(String variableName)`
  `static final CompareQuery`
  `lt(String variableName, boolean value)`
  `static final CompareQuery`
  `lt(String variableName, double value)`
  `static final CompareQuery`
  `lt(String variableName, long value)`
  `static final CompareQuery`
  `lt(String variableName, String value)`
  `static final CompareQuery`
  `lt(String variableName, Date value)`
  `static final CompareQuery`
  `lte(String variableName, boolean value)`
  `static final CompareQuery`
  `lte(String variableName, double value)`
  `static final CompareQuery`
  `lte(String variableName, long value)`
  `static final CompareQuery`
  `lte(String variableName, String value)`
  `static final CompareQuery`
  `lte(String variableName, Date value)`
  `static final MatchQuery`
  `match(String variableName, String value)`
  `static final MatchQuery`
  `matchAll(String variableName, String value)`
  `static final MatchQuery`
  `matchPhrase(String variableName, String value)`
  `static final MatchQuery`
  `matchPhrasePrefix(String variableName, String value)`
  `static final ExistsQuery`
  `missing(String variableName)`
  Deprecated.
  Use $not + $exists
  `static final MltQuery`
  `mlt(String value, String... variableName)`
  `static final CompareQuery`
  `ne(String variableName, boolean value)`
  `static final CompareQuery`
  `ne(String variableName, double value)`
  `static final CompareQuery`
  `ne(String variableName, long value)`
  `static final CompareQuery`
  `ne(String variableName, String value)`
  `static final CompareQuery`
  `ne(String variableName, Date value)`
  `static final NestedQuery`
  `nestedSearch(String variableName, com.fasterxml.jackson.databind.JsonNode value)`
  `static final InQuery`
  `nin(String variableName, boolean... value)`
  `static final InQuery`
  `nin(String variableName, double... value)`
  `static final InQuery`
  `nin(String variableName, long... value)`
  `static final InQuery`
  `nin(String variableName, String... value)`
  `static final InQuery`
  `nin(String variableName, Date... value)`
  `static final BooleanQuery`
  `not()`
  `static final BooleanQuery`
  `or()`
  `static final PathQuery`
  `path(String... pathes)`
  `static final RangeQuery`
  `range(String variableName, double min, boolean includeMin, double max, boolean includeMax)`
  `static final RangeQuery`
  `range(String variableName, long min, boolean includeMin, long max, boolean includeMax)`
  `static final RangeQuery`
  `range(String variableName, String min, boolean includeMin, String max, boolean includeMax)`
  `static final RangeQuery`
  `range(String variableName, Date min, boolean includeMin, Date max, boolean includeMax)`
  `static final SearchQuery`
  `regex(String variableName, String value)`
  `static final SearchQuery`
  `search(String variableName, String value)`
  `static final CompareQuery`
  `size(String variableName, long value)`
  Deprecated.
  `static final TermQuery`
  `term(String variableName, boolean value)`
  `static final TermQuery`
  `term(String variableName, double value)`
  `static final TermQuery`
  `term(String variableName, long value)`
  `static final TermQuery`
  `term(String variableName, String value)`
  `static final TermQuery`
  `term(String variableName, Date value)`
  `static final TermQuery`
  `term(Map<String,Object> variableNameValue)`
  `static final WildcardQuery`
  `wildcard(String variableName, String value)`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### QueryHelper

    protected QueryHelper()

- ## Method Details

  - ### path

    public static final PathQuery path(String... pathes) throws InvalidCreateOperationException
    Parameters:
      `pathes` - primary list of path in the future PathQuery
    Returns:
      a PathQuery
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### and

    public static final BooleanQuery and() throws InvalidCreateOperationException
    Returns:
      a BooleanQuery for AND operator
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### or

    public static final BooleanQuery or() throws InvalidCreateOperationException
    Returns:
      a BooleanQuery for OR operator
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### not

    public static final BooleanQuery not() throws InvalidCreateOperationException
    Returns:
      a BooleanQuery for NOT operator (using AND internally)
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### eq

    public static final CompareQuery eq(String variableName, boolean value) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `value` - of key
    Returns:
      a CompareQuery using EQ comparator
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### eq

    public static final CompareQuery eq(String variableName, long value) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `value` - of key
    Returns:
      a CompareQuery using EQ comparator
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### eq

    public static final CompareQuery eq(String variableName, double value) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `value` - of key
    Returns:
      a CompareQuery using EQ comparator
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### eq

    public static final CompareQuery eq(String variableName, String value) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `value` - of key
    Returns:
      a CompareQuery using EQ comparator
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### eq

    public static final CompareQuery eq(String variableName, Date value) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `value` - of key
    Returns:
      a CompareQuery using EQ comparator
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### ne

    public static final CompareQuery ne(String variableName, boolean value) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `value` - of key
    Returns:
      a CompareQuery using NE (non equal) comparator
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### ne

    public static final CompareQuery ne(String variableName, long value) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `value` - of key
    Returns:
      a CompareQuery using NE (non equal) comparator
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### ne

    public static final CompareQuery ne(String variableName, double value) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `value` - of key
    Returns:
      a CompareQuery using NE (non equal) comparator
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### ne

    public static final CompareQuery ne(String variableName, String value) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `value` - of key
    Returns:
      a CompareQuery using NE (non equal) comparator
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### ne

    public static final CompareQuery ne(String variableName, Date value) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `value` - of key
    Returns:
      a CompareQuery using NE (non equal) comparator
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### lt

    public static final CompareQuery lt(String variableName, boolean value) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `value` - of key
    Returns:
      a CompareQuery using LT (less than) comparator
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### lt

    public static final CompareQuery lt(String variableName, long value) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `value` - of key
    Returns:
      a CompareQuery using LT (less than) comparator
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### lt

    public static final CompareQuery lt(String variableName, double value) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `value` - of key
    Returns:
      a CompareQuery using LT (less than) comparator
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### lt

    public static final CompareQuery lt(String variableName, String value) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `value` - of key
    Returns:
      a CompareQuery using LT (less than) comparator
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### lt

    public static final CompareQuery lt(String variableName, Date value) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `value` - of key
    Returns:
      a CompareQuery using LT (less than) comparator
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### lte

    public static final CompareQuery lte(String variableName, boolean value) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `value` - of key
    Returns:
      a CompareQuery using LTE (less than or equal) comparator
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### lte

    public static final CompareQuery lte(String variableName, long value) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `value` - of key
    Returns:
      a CompareQuery using LTE (less than or equal) comparator
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### lte

    public static final CompareQuery lte(String variableName, double value) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `value` - of key
    Returns:
      a CompareQuery using LTE (less than or equal) comparator
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### lte

    public static final CompareQuery lte(String variableName, String value) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `value` - of key
    Returns:
      a CompareQuery using LTE (less than or equal) comparator
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### lte

    public static final CompareQuery lte(String variableName, Date value) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `value` - of key
    Returns:
      a CompareQuery using LTE (less than or equal) comparator
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### gt

    public static final CompareQuery gt(String variableName, boolean value) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `value` - of key
    Returns:
      a CompareQuery using GT (greater than) comparator
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### gt

    public static final CompareQuery gt(String variableName, long value) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `value` - of key
    Returns:
      a CompareQuery using GT (greater than) comparator
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### gt

    public static final CompareQuery gt(String variableName, double value) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `value` - of key
    Returns:
      a CompareQuery using GT (greater than) comparator
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### gt

    public static final CompareQuery gt(String variableName, String value) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `value` - of key
    Returns:
      a CompareQuery using GT (greater than) comparator
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### gt

    public static final CompareQuery gt(String variableName, Date value) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `value` - of key
    Returns:
      a CompareQuery using GT (greater than) comparator
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### gte

    public static final CompareQuery gte(String variableName, boolean value) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `value` - of key
    Returns:
      a CompareQuery using GTE (greater than or equal) comparator
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### gte

    public static final CompareQuery gte(String variableName, long value) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `value` - of key
    Returns:
      a CompareQuery using GTE (greater than or equal) comparator
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### gte

    public static final CompareQuery gte(String variableName, double value) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `value` - of key
    Returns:
      a CompareQuery using GTE (greater than or equal) comparator
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### gte

    public static final CompareQuery gte(String variableName, String value) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `value` - of key
    Returns:
      a CompareQuery using GTE (greater than or equal) comparator
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### gte

    public static final CompareQuery gte(String variableName, Date value) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `value` - of key
    Returns:
      a CompareQuery using GTE (greater than or equal) comparator
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### size

    public static final CompareQuery size(String variableName, long value) throws InvalidCreateOperationException
    Deprecated.
    Parameters:
      `variableName` - key name
      `value` - of key
    Returns:
      a CompareQuery using SIZE comparator
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### exists

    public static final ExistsQuery exists(String variableName) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
    Returns:
      an ExistsQuery
    Throws:
      `InvalidCreateOperationException` - using Exists operator

  - ### missing

    @Deprecated public static final ExistsQuery missing(String variableName) throws InvalidCreateOperationException
    Deprecated.
    Use $not + $exists
    Parameters:
      `variableName` - key name
    Returns:
      an ExistsQuery using Missing operator
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### isNull

    public static final ExistsQuery isNull(String variableName) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
    Returns:
      an ExistsQuery using isNull operator
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### in

    public static final InQuery in(String variableName, boolean... value) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `value` - of key
    Returns:
      an InQuery using IN operator
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### in

    public static final InQuery in(String variableName, long... value) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `value` - of key
    Returns:
      an InQuery using IN operator
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### in

    public static final InQuery in(String variableName, double... value) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `value` - of key
    Returns:
      an InQuery using IN operator
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### in

    public static final InQuery in(String variableName, String... value) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `value` - of key
    Returns:
      an InQuery using IN operator
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### in

    public static final InQuery in(String variableName, Date... value) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `value` - of key
    Returns:
      an InQuery using IN operator
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### nin

    public static final InQuery nin(String variableName, boolean... value) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `value` - of key
    Returns:
      an InQuery using NIN (not in) operator
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### nin

    public static final InQuery nin(String variableName, long... value) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `value` - of key
    Returns:
      an InQuery using NIN (not in) operator
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### nin

    public static final InQuery nin(String variableName, double... value) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `value` - of key
    Returns:
      an InQuery using NIN (not in) operator
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### nin

    public static final InQuery nin(String variableName, String... value) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `value` - of key
    Returns:
      an InQuery using NIN (not in) operator
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### nin

    public static final InQuery nin(String variableName, Date... value) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `value` - of key
    Returns:
      an InQuery using NIN (not in) operator
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### match

    public static final MatchQuery match(String variableName, String value) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `value` - of key
    Returns:
      a MatchQuery using MATCH operator
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### matchAll

    public static final MatchQuery matchAll(String variableName, String value) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `value` - of key
    Returns:
      a MatchQuery using MATCH operator
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### matchPhrase

    public static final MatchQuery matchPhrase(String variableName, String value) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `value` - of key
    Returns:
      a MatchQuery using MATCH_PHRASE operator
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### matchPhrasePrefix

    public static final MatchQuery matchPhrasePrefix(String variableName, String value) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `value` - of key
    Returns:
      a MatchQuery using MATCH_PHRASE_PREFIX operator
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### regex

    public static final SearchQuery regex(String variableName, String value) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `value` - of key
    Returns:
      a SearchQuery using REGEX operator
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### search

    public static final SearchQuery search(String variableName, String value) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `value` - of key
    Returns:
      a SearchQuery using SEARCH operator
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### nestedSearch

    public static final NestedQuery nestedSearch(String variableName, com.fasterxml.jackson.databind.JsonNode value) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `value` - of key
    Returns:
      a NestedQuery using Nested Search operator
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### term

    public static final TermQuery term(String variableName, String value) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `value` - of key
    Returns:
      a TermQuery
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### term

    public static final TermQuery term(String variableName, long value) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `value` - of key
    Returns:
      a TermQuery
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### term

    public static final TermQuery term(String variableName, double value) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `value` - of key
    Returns:
      a TermQuery
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### term

    public static final TermQuery term(String variableName, boolean value) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `value` - of key
    Returns:
      a TermQuery
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### term

    public static final TermQuery term(String variableName, Date value) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `value` - of key
    Returns:
      a TermQuery
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### term

    public static final TermQuery term(Map<String,Object> variableNameValue) throws InvalidCreateOperationException
    Parameters:
      `variableNameValue` - key nameValue Map of VariableName of Value
    Returns:
      a TermQuery
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### wildcard

    public static final WildcardQuery wildcard(String variableName, String value) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `value` - of key
    Returns:
      a WildcardQuery
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### flt

    public static final MltQuery flt(String value, String... variableName) throws InvalidCreateOperationException
    Parameters:
      `value` - of key
      `variableName` - key name
    Returns:
      a MltQuery using a FLT (fuzzy like this) operator
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### mlt

    public static final MltQuery mlt(String value, String... variableName) throws InvalidCreateOperationException
    Parameters:
      `value` - of key
      `variableName` - key name
    Returns:
      a MltQuery using a MLT (more like this) operator
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### range

    public static final RangeQuery range(String variableName, long min, boolean includeMin, long max, boolean includeMax) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `min` - value
      `includeMin` - include min value
      `max` - value
      `includeMax` - include max value
    Returns:
      a RangeQuery
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### range

    public static final RangeQuery range(String variableName, double min, boolean includeMin, double max, boolean includeMax) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `min` - value
      `includeMin` - include min value
      `max` - value
      `includeMax` - include max value
    Returns:
      a RangeQuery
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### range

    public static final RangeQuery range(String variableName, String min, boolean includeMin, String max, boolean includeMax) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `min` - value
      `includeMin` - include min value
      `max` - value
      `includeMax` - include max value
    Returns:
      a RangeQuery
    Throws:
      `InvalidCreateOperationException` - when creating query errors

  - ### range

    public static final RangeQuery range(String variableName, Date min, boolean includeMin, Date max, boolean includeMax) throws InvalidCreateOperationException
    Parameters:
      `variableName` - key name
      `min` - value
      `includeMin` - include min value
      `max` - value
      `includeMax` - include max value
    Returns:
      a RangeQuery
    Throws:
      `InvalidCreateOperationException` - when creating query errors